- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Public Attributes | Friends | List of all members
ClarisWksStruct::DSET Struct Reference

main structure which correspond to a document part More...

`#include <ClarisWksStruct.hxx>`

Inheritance diagram for ClarisWksStruct::DSET:

## Classes
struct | Child
| structure used to define the child of a DSET structure More...

## Public Types
enum | Position { P_Main =0, P_Header, P_Footer, P_Frame, P_Footnote, P_Table, P_GraphicMaster, P_Slide, P_SlideNote, P_SlideThumbnail, P_SlideMaster, P_Unknown }
| the zone position More...
enum | ChildType { C_Zone, C_SubText, C_Graphic, C_Unknown }
| the different types of zone child More...

## Public Member Functions
| DSET ()
| constructor More...
virtual | ~DSET ()
| virtual destructor More...
bool | isHeaderFooter () const
| test if the zone is an header/footer More...
bool | isSlide () const
| test if the zone is a slide More...
Box2f | getBdBox () const
| return the zone bdbox More...
int | getMaximumPage () const
| returns the maximum page More...
virtual void | removeChild (int cId, bool normalChild)
| virtual function to remove a child from a list More...
virtual void | removeChild (int cId)
| virtual function to remove a child from a list More...
void | updateChildPositions (Vec2f const &pageDim, float formLength, int numHorizontalPages=1)
| try to update the child page and bounding box More...
void | findForbiddenPagesBreaking (float pageDim, float formDim, int dim, std::set< int > &forbiddenPageBreak) const
| find forbidden page break More...
Box2i | getUnionChildBox () const
| returns the child box (ie. the union of the childs box) More...

## Public Attributes
long | m_size
| the size of the DSET header More...
long | m_numData
| the number of header More...
long | m_dataSz
| the data size More...
long | m_headerSz
| the header size More...
Position | m_position
| the zone type More...
int | m_fileType
| the type ( 0: text, -1: graphic, ...) More...
int | m_page
| the page (if known) More...
Box2f | m_box
| the bounding box (if known) More...
Vec2f | m_pageDimension
| the page dimension (if know) More...
int | m_id
| the zone identificator More...
std::set< int > | m_fathersList
| the list of fathers More...
int | m_beginSelection
| the begin of selection ( at least in text header) More...
int | m_endSelection
| the end of selection ( at least in text header) More...
int | m_textType
| the text type (header/footer,footnote, ...) More...
int | m_flags [4]
| some unknown flag More...
std::vector< Child > | m_childs
| the list of child zone More...
std::vector< int > | m_otherChilds
| the list of other child More...
bool | m_parsed
| a flag to know if the entry is sent or not to the listener More...
int | m_internal
| an internal variable used to do some computation More...

## Friends
std::ostream & | operator<< (std::ostream &o, DSET const &doc)
| operator<< More...

## Detailed Description

main structure which correspond to a document part

## Member Enumeration Documentation

enum ClarisWksStruct::DSET::ChildType

the different types of zone child

Enumerator
C_Zone |
C_SubText |
C_Graphic |
C_Unknown |

enum ClarisWksStruct::DSET::Position

the zone position

Enumerator
P_Main |
P_Header |
P_Footer |
P_Frame |
P_Footnote |
P_Table |
P_GraphicMaster |
P_Slide |
P_SlideNote |
P_SlideThumbnail |
P_SlideMaster |
P_Unknown |

## Constructor & Destructor Documentation

ClarisWksStruct::DSET::DSET | ( |  | ) |
| inline

constructor

virtual ClarisWksStruct::DSET::~DSET | ( |  | ) |
| inline virtual

virtual destructor

## Member Function Documentation

void ClarisWksStruct::DSET::findForbiddenPagesBreaking | ( | float | pageDim,
|  | float | formDim,
|  | int | dim,
|  | std::set< int > & | forbiddenPageBreak
| ) |  | const

find forbidden page break

Box2f ClarisWksStruct::DSET::getBdBox | ( |  | ) | const
| inline

return the zone bdbox

int ClarisWksStruct::DSET::getMaximumPage | ( |  | ) | const
| inline

returns the maximum page

Box2i ClarisWksStruct::DSET::getUnionChildBox | ( |  | ) | const

returns the child box (ie. the union of the childs box)

bool ClarisWksStruct::DSET::isHeaderFooter | ( |  | ) | const
| inline

test if the zone is an header/footer

Referenced by findForbiddenPagesBreaking(), and ClarisWksGraph::updateGroup().

bool ClarisWksStruct::DSET::isSlide | ( |  | ) | const
| inline

test if the zone is a slide

Referenced by ClarisWksGraph::sendGroup().

void ClarisWksStruct::DSET::removeChild | ( | int | cId,
|  | bool | normalChild
| ) |  |
| virtual

virtual function to remove a child from a list

Reimplemented in ClarisWksGraphInternal::Group, ClarisWksTextInternal::Zone, ClarisWksTableInternal::Table, and ClarisWksPresentationInternal::Presentation.

Referenced by removeChild().

void ClarisWksStruct::DSET::removeChild | ( | int | cId | ) |
| virtual

virtual function to remove a child from a list

void ClarisWksStruct::DSET::updateChildPositions | ( | Vec2f const & | pageDim,
|  | float | formLength,
|  | int | numHorizontalPages = `1`
| ) |  |

try to update the child page and bounding box

## Friends And Related Function Documentation

std::ostream& operator<< | ( | std::ostream & | o,
|  | DSET const & | doc
| ) |  |
| friend

operator<<

## Member Data Documentation

int ClarisWksStruct::DSET::m_beginSelection

the begin of selection ( at least in text header)

Referenced by ClarisWksStruct::operator<<(), and ClarisWksDocument::readDSET().

Box2f ClarisWksStruct::DSET::m_box

the bounding box (if known)

Referenced by getBdBox(), ClarisWksStruct::operator<<(), ClarisWksGraph::sendGroup(), and updateChildPositions().

std::vector<Child> ClarisWksStruct::DSET::m_childs

the list of child zone

Referenced by findForbiddenPagesBreaking(), getMaximumPage(), getUnionChildBox(), ClarisWksStruct::operator<<(), removeChild(), updateChildPositions(), and ClarisWksGraph::updateGroup().

long ClarisWksStruct::DSET::m_dataSz

the data size

Referenced by ClarisWksStruct::operator<<(), ClarisWksGraph::readBitmapZone(), ClarisWksDatabase::readDatabaseZone(), ClarisWksDocument::readDSET(), ClarisWksGraph::readGroupZone(), ClarisWksPresentation::readPresentationZone(), ClarisWksSpreadsheet::readSpreadsheetZone(), and ClarisWksTable::readTableZone().

int ClarisWksStruct::DSET::m_endSelection

the end of selection ( at least in text header)

Referenced by ClarisWksStruct::operator<<(), and ClarisWksDocument::readDSET().

std::set<int> ClarisWksStruct::DSET::m_fathersList

the list of fathers

Referenced by ClarisWksStruct::operator<<().

int ClarisWksStruct::DSET::m_fileType

the type ( 0: text, -1: graphic, ...)

Referenced by ClarisWksStruct::operator<<(), ClarisWksGraph::readBitmapZone(), ClarisWksDatabase::readDatabaseZone(), ClarisWksDocument::readDSET(), ClarisWksText::readDSETZone(), ClarisWksGraph::readGroupZone(), ClarisWksPresentation::readPresentationZone(), ClarisWksSpreadsheet::readSpreadsheetZone(), and ClarisWksTable::readTableZone().

int ClarisWksStruct::DSET::m_flags[4]

some unknown flag

Referenced by DSET(), ClarisWksStruct::operator<<(), and ClarisWksDocument::readDSET().

long ClarisWksStruct::DSET::m_headerSz

the header size

Referenced by ClarisWksStruct::operator<<(), ClarisWksGraph::readBitmapZone(), ClarisWksDatabase::readDatabaseZone(), ClarisWksDocument::readDSET(), ClarisWksGraph::readGroupZone(), ClarisWksPresentation::readPresentationZone(), ClarisWksSpreadsheet::readSpreadsheetZone(), and ClarisWksTable::readTableZone().

int ClarisWksStruct::DSET::m_id

the zone identificator

Referenced by ClarisWksStruct::operator<<(), ClarisWksDocument::readDSET(), ClarisWksText::readDSETZone(), ClarisWksPresentationInternal::Presentation::removeChild(), ClarisWksTableInternal::Table::removeChild(), ClarisWksGraph::sendGroup(), and ClarisWksText::sendText().

int ClarisWksStruct::DSET::m_internal
| mutable

an internal variable used to do some computation

long ClarisWksStruct::DSET::m_numData

the number of header

Referenced by ClarisWksStruct::operator<<(), ClarisWksGraph::readBitmapZone(), ClarisWksDatabase::readDatabaseZone(), ClarisWksDocument::readDSET(), ClarisWksText::readDSETZone(), ClarisWksGraph::readGroupZone(), ClarisWksPresentation::readPresentationZone(), ClarisWksSpreadsheet::readSpreadsheetZone(), and ClarisWksTable::readTableZone().

std::vector<int> ClarisWksStruct::DSET::m_otherChilds

the list of other child

Referenced by ClarisWksStruct::operator<<(), ClarisWksDatabase::readLayout(), ClarisWksTable::readTableCells(), ClarisWksText::readTextSection(), ClarisWksPresentation::readZone1(), and removeChild().

int ClarisWksStruct::DSET::m_page

the page (if known)

Referenced by ClarisWksGraph::canSendAsGraphic(), getMaximumPage(), ClarisWksGraphInternal::Group::Group(), ClarisWksStruct::operator<<(), ClarisWksGraph::sendGroup(), and updateChildPositions().

Vec2f ClarisWksStruct::DSET::m_pageDimension

the page dimension (if know)

Referenced by findForbiddenPagesBreaking(), ClarisWksStruct::operator<<(), ClarisWksGraph::readGroupUnknown(), and updateChildPositions().

bool ClarisWksStruct::DSET::m_parsed
| mutable

a flag to know if the entry is sent or not to the listener

Referenced by ClarisWksGraph::sendBitmap(), ClarisWksGraph::sendGroup(), ClarisWksGraph::sendPageChild(), and ClarisWksText::sendText().

Position ClarisWksStruct::DSET::m_position

the zone type

Referenced by ClarisWksGraph::canSendAsGraphic(), findForbiddenPagesBreaking(), getMaximumPage(), isHeaderFooter(), isSlide(), ClarisWksStruct::operator<<(), ClarisWksGraph::sendGroup(), updateChildPositions(), and ClarisWksGraph::updateGroup().

long ClarisWksStruct::DSET::m_size

the size of the DSET header

Referenced by ClarisWksDocument::readDSET().

int ClarisWksStruct::DSET::m_textType

the text type (header/footer,footnote, ...)

Referenced by ClarisWksStruct::operator<<(), and ClarisWksDocument::readDSET().

The documentation for this struct was generated from the following files:

- ClarisWksStruct.hxx
- ClarisWksStruct.cxx